import DashView from './components/Dash.vue'
import LoginView from './components/Login.vue'
import SignupView from './components/Signup.vue'
import NotFoundView from './components/404.vue'
import TablesView from './components/views/Tables.vue'

// Routes
const routes = [
  {
    path: '/',
    component: LoginView
  },
  {
    path: '/signup',
    component: SignupView
  },
  {
    path: '/tables',
    component: DashView,
    children: [
      {
        path: 'tables',
        alias: '',
        component: TablesView,
        name: 'Transactions',
        meta: {description: 'Simple and advance table in CoPilot'}
      }
    ]
  }, {
    // not found handler
    path: '*',
    component: NotFoundView
  }
]

export default routes
